#include<stdlib.h>
#include<stdio.h>

struct binary_tree {
    int data;
    struct binary_tree *right, *left;
};

typedef struct binary_tree node;

void insert(node **tree, int val) {
    // If the node is empty, add the data to this node. Otherwise, decide whether to insert on the left or the right. 
    node *temp = NULL;
    if(!(*tree)) {
        temp = (node *)malloc(sizeof(node));
        temp->left = temp->right = NULL;
        temp->data = val;
        *tree = temp;
        return;
    }

    if(val < (*tree)->data) {
        insert(&(*tree)->left, val);
    } else if(val > (*tree)->data) {
        insert(&(*tree)->right, val);
    }

}

void print_tree(node * tree) {
    // Recursively print the tree, node by node
    if (tree) {
        printf("%d\n",tree->data);
        print_tree(tree->left);
        print_tree(tree->right);
    }
}

int main() {
    node *root;
    node *tmp;
    //int i;

    root = NULL;
    /* Inserting nodes into tree */
    insert(&root, 50);
    insert(&root, 28);
    insert(&root, 94);
    insert(&root, 35);
    insert(&root, 66);
    insert(&root, 33);
    insert(&root, 89);

    /* Printing nodes of tree */
    printf("Printing tree\n");
    print_tree(root);
}

