# Perl Implementation of Linked List
# Approach 1: uses reference variables, or pointers
#
# Implementations at
# https://tjhsst.edu/~dhyatt/perl/ex8.html
#
# charles reid
# March 2013
# Adding comments

print "Linked Lists using Reference Variables/Pointers:\n";

# 
# Reference Variables, or Pointers
#

# These "links" are just integer index values, indicating which node points to which other node.
@links = qw( 1 2 3 4 5 6 Null );

# These "nodes" are all initialized with data (colors) and links (Null)
@nodes = qw (blue:Null green:Null yellow:Null orange:Null red:Null purple:Null brown:Null);

# Now use a for loop to update each node's link, using @links
for ($i = 0; $i <= $#nodes; $i++) { 

	# Get a pointer to this node
	$ptr = \$nodes[$i];
	
	# The data "blue:Null" is a string that we need to split.
	# data[0] will contain the data
	# data[1] will contain the link
    @data = split(/:/,$$ptr);
    print "Before:  $ptr  @data ";

	# Update the link using @links at i
    $data[1] = $links[$i];
    print "->  @data \n";

	# Now that we've updated the link, we need to re-combine the data and link, and put it back in the array.
    $$ptr = join ':',@data;
}

# Print out the new linked list nodes array:
print "\n\n";
print "@nodes";
print "\n\n";



# Print the linked list:
print "Traversing list:\n";
$next = 0;
while ($next !~ "Null") {
	@data = split(":",$nodes[$next]);
	print $data[0], "\n";
	$next = $data[1];
}

print "\n\n"



